#include <def21161.h>

#define N 256

.section/dm seg_sram;
.var destination[N];

.section/dm seg_dmda;
.var sourceHost[N];
.var hostDest[N];

.var hostDMA_tcb[8] = 0,0,0,0,0x40000,N,1,hostDest;//set PCI bit in CP bit 17;

.var host_count = 0;
.var hostDMA_flag = 0;

.var error_flag = 0;
.var error_count = 0;
.var error_buffer[N];

.var error1_flag = 0;
.var error1_count = 0;
.var error1_buffer[N];

.section/pm seg_rth;

//EMUI:
	nop;
	nop;
	nop;
	nop;
	
//RSTI:
	nop;
	jump start;
	nop;
	nop;
	
.section/pm seg_epb;

//EPB0I:
	nop;
	nop;
	nop;
	nop;
	
//EPB1I:
	nop;
	jump host_isr;
	nop;
	nop;
	
//EPB2I:
	nop;
	nop;
	nop;
	nop;
		
//EPB3I:
	nop;
	nop;
	nop;
	nop;	
	
.section/pm seg_pmco;
start:
	r0 = 0x1000;
	dm(SDRDIV) = r0;
	
	r0 = 0x02214231;
	dm(SDCTL) = r0;
	
	r0 = 0x018c0142;
	dm(EPCON) = r0;	
	
	bit set mode2 FLG2O;
	
	ustat1 = dm(IOFLAG);
	bit set ustat1 FLG5O;
	dm(IOFLAG) = ustat1;
	
	bit clr ustat1 FLG5;
	dm(IOFLAG) = ustat1;
	
	bit clr flags FLG2;
	
	bit clr mode1 CBUFEN;
	
	i1 = sourceHost;
	m0 = 1;
	l1 = 0;
	r0 = 0x0;
	
	lcntr = N, do _init until lce;
	r2 = lshift r0 by 10;
	dm(i1,m0) = r2;
_init: r0 = r0 + 1;	

	bit set imask EP1I;
	bit set mode1 IRPTEN;
	
	bit set mode1 CBUFEN;
	
	b2 = error1_buffer;
	m2 = 1;
	l2 = @error1_buffer;
	
	l3 = 0;
	l4 = 0;
	l0 = 0;
	
	call Enable_DMAs;	

loophere:
	nop;
	nop;
check_hostflag:
	r3 = dm(hostDMA_flag);
	r4 = 1;
	comp(r3,r4);
	if ne jump check_hostflag; 
	r4 = 0;
	dm(hostDMA_flag) = r4;
	
	call Compare_Host_Data;
	
	call Enable_DMAs;
	
	jump loophere;	
	
host_isr:
	r0 = dm(host_count);
	r0 = r0 + 1;
	dm(host_count) = r0;
	
	r0 = 1;
	dm(hostDMA_flag) = r0;
	
	rti;

Enable_DMAs:
			
	ustat1 =  CHEN | DEN | INT32 | PMODE4;
	dm(DMAC11) = ustat1;
	
	r0 = hostDMA_tcb;
	r1 = 7;
	r0 = r0 + r1;

	dm(CP11) = r0;
	
	i0 = 0x120008;
	m0 = 0;
	r0 = 2;
	
	dm(i0,m0) = r0;
	
	rts;
	
Compare_Host_Data:

	i3 = sourceHost;
	i4 = hostDest;
	m3 = 1;
	nop;
	
	LCNTR = N, do compare_data1 until lce;
	r0 = dm(i3,m3);
	r2 = dm(i4,m3);	
	comp (r0,r2);
	if eq jump compare_data1;
	
	bit set flags FLG2;
	
	ustat1 = dm(IOFLAG);
	bit set ustat1 FLG5;
	dm(IOFLAG) = ustat1;	
	
	dm(i2,m2) = r0;
	dm(i2,m2) = r2;
	
	r2 = 1;
	dm(error1_flag) = r2;
	
compare_data1: nop; nop; nop;

	r1 = 0;
	r0 = dm(error1_flag);
	comp(r0,r1);
	if eq jump exit_subroutine1;
	
	dm(error1_flag) = r1;
	
	r2 = dm(error1_count);
	r2 = r2 + 1;
	dm(error1_count) = r2;

exit_subroutine1:	
	rts;		
	
